/******/ (() => { // webpackBootstrap
/******/ 	var __webpack_modules__ = ({

/***/ "./parallel-each.js":
/*!**************************!*\
  !*** ./parallel-each.js ***!
  \**************************/
/***/ ((module) => {

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function EventEmitter() {
  this.events = {};
}

;

EventEmitter.prototype.on = function (event, listener) {
  if (_typeof(this.events[event]) !== 'object') {
    this.events[event] = [];
  }

  this.events[event].push(listener);
};

EventEmitter.prototype.emit = function (event) {
  var i,
      listeners,
      length,
      args = [].slice.call(arguments, 1);

  if (_typeof(this.events[event]) === 'object') {
    listeners = this.events[event].slice();
    length = listeners.length;

    for (i = 0; i < length; i++) {
      listeners[i].apply(this, args);
    }
  }
};

function ParallelEach(array, callback, chunkSize) {
  var _this = this;

  this.callback = callback || function () {};

  this.array = array || [];
  this.chunkSize = chunkSize || 1;
  this.ee = new EventEmitter();
  this.erroredItems = [];
  this.processArray = this.array.slice(0, chunkSize).map(function (item, i) {
    return {
      index: i,
      item: item
    };
  });
  this.availableIndexes = this.array.map(function (_, i) {
    return i;
  }).slice(chunkSize);

  this.processCallback = function (item) {
    return new Promise(function (resolve) {
      Promise.resolve(_this.callback(item.item, item.index, _this.array))["catch"](function (ex) {
        _this.ee.emit('itemError', {
          item: item,
          ex: ex
        });
      }).then(resolve);
    })["catch"](function (ex) {
      _this.ee.emit('itemError', {
        item: item,
        ex: ex
      });
    }).then(function () {
      _this.processArray = _this.processArray.filter(function (val) {
        return item !== val;
      });
      var nextIndex = null;

      if (_this.availableIndexes && _this.availableIndexes.length) {
        nextIndex = _this.availableIndexes.splice(0, 1)[0];

        _this.processArray.push({
          index: nextIndex,
          item: _this.array[nextIndex]
        });
      }

      _this.ee.emit('itemComplete', nextIndex);
    });
  };

  this.process = function () {
    return new Promise(function (resolve) {
      _this.ee.on('itemError', function (e) {
        _this.erroredItems.push({
          item: e.item.item,
          index: e.item.index,
          exception: e.ex
        });
      });

      _this.ee.on('itemComplete', function () {
        var nextIndex = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

        if (nextIndex === null && !_this.processArray.length) {
          return resolve(_this.erroredItems);
        }

        if (nextIndex !== null) {
          var nextItem = _this.processArray.find(function (item) {
            return item.index === nextIndex;
          });

          if (nextItem) {
            _this.processCallback(nextItem);
          }
        }
      });

      if (_this.processArray.length) {
        for (var i = 0; i < _this.processArray.length; i++) {
          _this.processCallback(_this.processArray[i]);
        }
      } else {
        _this.ee.emit('itemComplete');
      }
    });
  };

  return this.process();
}

;

module.exports = function (array, callback) {
  var chunkSize = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1;
  return new ParallelEach(array, callback, chunkSize);
};

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		if(__webpack_module_cache__[moduleId]) {
/******/ 			return __webpack_module_cache__[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	// startup
/******/ 	// Load entry module
/******/ 	// This entry module is referenced by other modules so it can't be inlined
/******/ 	__webpack_require__("./parallel-each.js");
/******/ })()
;
//# sourceMappingURL=parallel-each.js.map